unit CustomAttribute;

interface

type
  TMyCustomAttribute = class(TCustomAttribute)
  private
    FAttrValue : Integer;
  public
    constructor Create(AttrValue: Integer);
    property CustomValue : Integer read FAttrValue write FAttrValue;
  end;

  procedure ShowCustomAttributes (aType: System.Type);

implementation

uses
  System.Reflection, SysUtils;

constructor TMyCustomAttribute.Create(AttrValue: Integer);
begin
  inherited Create;
  CustomValue := AttrValue;
end;

procedure ShowAttribs (attribs: array of System.Object);
begin
  // show only the first one...
  if Length (attribs) > 0 then
  begin
    write (' ---> ' + attribs[0].ToString);
    write ('(' + IntToStr ((attribs[0] as TMyCustomAttribute).
      CustomValue) + ')' );
  end;
end;

procedure ShowCustomAttributes (aType: System.Type);
var
  members : array of System.Reflection.MemberInfo;
  I: Integer;
  mtypes: System.Reflection.MemberTypes;
begin
  write (aType.Name);
  ShowAttribs (aType.GetCustomAttributes
    (TMyCustomAttribute.ClassInfo, True));
  writeln;

  members := aType.GetMembers;
  for I := 0 to High(members) do
  begin
    mtypes := members[i].MemberType;
    write (aType.Name + ':' + members[i].Name +
      ' (' + TObject(mtypes).ToString + ')');
    ShowAttribs (members[i].GetCustomAttributes
      (TMyCustomAttribute.ClassInfo, True));
    writeln; // new line
  end;
end;

end.
