program PrimitiveList;

{$APPTYPE CONSOLE}

uses
  SysUtils, System.Reflection, TypInfo;

procedure PrintDelphiType (tInfo: TTypeInfo; strComment: string = '');
begin
  write (tInfo.DelphiTypeName);
  write (' - ');
  write (tInfo.ToString);
  writeln (' ' + strComment);
end;

begin
  write ('Delphi');
  write (' - ');
  write ('CLR');
  writeln;

  writeln ('');
  writeln ('generic size');
  PrintDelphiType (typeInfo (Integer));
  PrintDelphiType (typeInfo (Cardinal), 'declared as Cardinal');

  writeln ('');
  writeln ('specific size: signed ');
  PrintDelphiType (typeInfo (ShortInt));
  PrintDelphiType (typeInfo (SmallInt));
  PrintDelphiType (typeInfo (LongInt));
  PrintDelphiType (typeInfo (Int64));

  writeln ('');
  writeln ('specific size: unsigned ');
  PrintDelphiType (typeInfo (Byte));
  PrintDelphiType (typeInfo (Word));
  PrintDelphiType (typeInfo (Longword));

  writeln ('');
  writeln ('floating');
  PrintDelphiType (typeInfo (Single));
  PrintDelphiType (typeInfo (Double));
  PrintDelphiType (typeInfo (Extended));
  PrintDelphiType (typeInfo (Comp), 'is deprecated');
  PrintDelphiType (typeInfo (Currency), 'record based on Decimal');
  PrintDelphiType (typeInfo (Decimal));
  PrintDelphiType (typeInfo (Real), 'declared as Real');
  // PrintDelphiType (typeInfo (Real48)); // gone, doesn't compile on .NET

  writeln ('');
  writeln ('char/string');
  PrintDelphiType (typeInfo (Char));
  PrintDelphiType (typeInfo (WideChar), 'declared as WideChar');
  PrintDelphiType (typeInfo (string));
  PrintDelphiType (typeInfo (AnsiChar));
  PrintDelphiType (typeInfo (ShortString));
  PrintDelphiType (typeInfo (AnsiString));
  PrintDelphiType (typeInfo (WideString), 'declared as WideString');

  writeln ('');
  writeln ('boolean');
  PrintDelphiType (typeInfo (Boolean));
  PrintDelphiType (typeInfo (ByteBool));
  PrintDelphiType (typeInfo (WordBool));
  PrintDelphiType (typeInfo (LongBool));

  Readln; //wait
end.
